package org.processmining.security.plugins.replayer;

import java.util.ArrayList;
import java.util.List;

import org.processmining.partialorder.models.palignment.Move;
import org.processmining.partialorder.models.palignment.PAlignment;

public class InterLevelSyncReplayResult implements Cloneable{
	private List<CompositeMove> compositeMoves;
	private PAlignment pAlignment;
	private String caseID;
	private List<Move> seqAlignment;
	private List<CompositeMove> compositeMovesWithAction;
	
	public InterLevelSyncReplayResult(String caseID){		
		compositeMoves = new ArrayList<CompositeMove>();
		this.caseID = caseID;
	}
	public InterLevelSyncReplayResult(List<CompositeMove> compositeMoves, String caseID){
		this.compositeMoves = compositeMoves;
		this.caseID = caseID;
	}
	public void addCompositeMove(CompositeMove compositeMove){
		compositeMoves.add(compositeMove);
	}
	public List<CompositeMove> getCompositeMoves() {
		return compositeMoves;
	}
	public InterLevelSyncReplayResult clone() throws CloneNotSupportedException {
		return new InterLevelSyncReplayResult(new ArrayList<CompositeMove>(compositeMoves), caseID);
	}
	public String toString() {
		String str = "";
		for (CompositeMove compositeMove : compositeMoves) {
			str += compositeMove.toString() + "->";
		}
		return str;
	}
	public void setPAlignment(PAlignment pAlignment) {
		this.pAlignment = pAlignment;
	}
	public PAlignment getPAlignment() {
		return pAlignment;
	}
	public List<Move> getSeqAlignment () {
		if(seqAlignment != null)
			return seqAlignment;
		
		seqAlignment = new ArrayList<Move>();
		for (CompositeMove compositeMove : compositeMoves) {
			if(compositeMove.getAlignmentMove() != null && !seqAlignment.contains(compositeMove.getAlignmentMove() ))
				seqAlignment.add(compositeMove.getAlignmentMove());
		}
		return seqAlignment;
	}
	public List<CompositeMove> getCompositeMovesWithAction () {
		if(compositeMovesWithAction != null)
			return compositeMovesWithAction;
		
		compositeMovesWithAction = new ArrayList<CompositeMove>();
		for (CompositeMove compositeMove : compositeMoves) {
			if(compositeMove.getCRUDEntry() != null || compositeMove.getSystemEvent() != null)
				compositeMovesWithAction.add(compositeMove);
		}
		return compositeMovesWithAction;
	}
	public String getCaseID() {
		return caseID;
	}
}
