package org.processmining.security.plugins.replayer.aStar;

import java.util.HashMap;

import org.processmining.partialorder.models.palignment.Move;
import org.processmining.security.plugins.replayer.CompositeMoveType;

public class CostFunction {
	private HashMap<CompositeMoveType, Double> cost;
	public CostFunction(HashMap<CompositeMoveType, Double> cost){
		this.cost = cost;
	}
	public double getCompositeMoveCost(CompositeMoveType stepType){
		return cost.get(stepType);		
	}
	public double getCompositeMoveCost(CompositeMoveType stepType, Move move){
		if(move != null && move.isSilentModelMove()){
			CompositeMoveType newStepType = null;
			switch(stepType){
				case MMODEL_PROC_SYNC_DATA:
					newStepType = CompositeMoveType.SYNC_PROC_SYNC_DATA;
					break;
				case MMODEL_PROC_MLOG_DATA:
					newStepType = CompositeMoveType.SYNC_PROC_MLOG_DATA;
					break;
				case MMODEL_PROC_MMODEL_DATA:
					newStepType = CompositeMoveType.SYNC_PROC_MMODEL_DATA;
					break;
				case MMODEL_PROC_NO_OP:
					newStepType = CompositeMoveType.SYNC_PROC_NO_OP;
					break;
			}
			return cost.get(newStepType);
		}else
			return cost.get(stepType);		
	}
}
