package org.processmining.security.plugins.ui;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.table.AbstractTableModel;

public class CostFunctionTableModel extends AbstractTableModel{

		/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//Two arrays used for the table data
    private List<String> columnNames;
    private String defaultCost [][] = 
    				{{"0", "2", "2", "-"},
    				{"1", "2", "2", "-"},
    				{"3", "4", "4", "5"},
    				{"0", "0", "0", "-"}};
    private String costFunction[][];
    private String columnHeader[] = {"", "Synch Process Move (e,a)", "Process Move on Model (>>,a)", "Process Move on Log (e,>>)", "No Process Move (>>,>>)"};
    private String rowHeader[] = {"Synch Data Move (s,r)", "Data Move on Model (>>,r)", "Data Move on Log (s,>>)", "No Data Move (>>,>>)"};
    public CostFunctionTableModel(){
    	columnNames = new ArrayList<String>();
    	costFunction = new String[4][4];
    	for (String header : columnHeader) {
    		columnNames.add(header);
		}
    	for(int i = 0; i < 4; i++)
    		for(int j = 0; j < 4; j++)
				costFunction[i][j] = defaultCost[i][j];
    }
    
	public int getColumnCount() {
		return 5;
	}

	public int getRowCount() {
		return 4;
	}
	@Override
    public String getColumnName(int column) {
        return columnNames.get(column);
    }
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		if(columnIndex == 0 || (columnIndex == 4 && rowIndex != 2))
			return false;
		return true;
	}
	public Object getValueAt(int rowIndex, int columnIndex) {
		if(columnIndex == 0)
			return rowHeader[rowIndex];
		return costFunction[rowIndex][columnIndex - 1];
	}
	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
		try{
		  Double.parseDouble(aValue.toString());
		  costFunction[rowIndex][columnIndex - 1] = aValue.toString();
		} catch(NumberFormatException e)
		{
			JOptionPane.showMessageDialog(
					new JPanel(),
					"You should assign a double value to each composite move.",
					"Input Validation", JOptionPane.ERROR_MESSAGE);
		}		
	}
	
}
